/* Problem URL: https://codeforces.com/problemset/problem/1787/D */

#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>

using namespace std;
using namespace __gnu_pbds;

template <class T, class comp = less<>>
using ordered_set = tree<T, null_type , comp , rb_tree_tag , tree_order_statistics_node_update>;

#define V vector

#define rmin(a, b) a = min(a, b)
#define rmax(a, b) a = max(a, b)

#define rep(i, lim) for (int i = 0; i < (lim); i++)
#define nrep(i, s, lim) for (int i = s; i < (lim); i++)

#define repv(i, v) for (auto &i : (v))
#define fillv(v) for (auto &itr_ : (v)) { cin >> itr_; }
#define sortv(v) sort(v.begin(), v.end())
#define all(v) (v).begin(), (v).end()

using vi = vector<int>;
using vvi = vector<vi>;
using vvvi = vector<vvi>;
using vvvvi = vector<vvvi>;

using ll = long long;

using vl = vector<ll>;
using vvl = vector<vl>;
using vvvl = vector<vvl>;
using vvvvl = vector<vvvl>;

template<class v>
auto operator<<(ostream &os, const vector<v> &vec)->ostream& {
    os << vec[0];
    for (size_t i = 1; i < vec.size(); i++) {
        os << ' ' << vec[i];
    }
    os << '\n';
    return os;
}

template<class v>
auto operator>>(istream &is, vector<v> &vec)->istream& {
    for (auto &i : vec) {
        is >> i;
    }
    return is;
}

template<class v>
auto operator<<(ostream &os, const vector<vector<v>> &vec)->ostream& {
    for (auto &i : vec) {
        os << i[0];
        for (size_t j = 1; j < i.size(); j++) {
            os << ' ' << i[j];
        }
        os << '\n';
    }
    return os;
}

template<class v>
auto operator>>(istream  &is, vector<vector<v>> &vec)->istream& {
    for (auto &i : vec) {
        for (auto &j : i) {
            is >> j;
        }
    }
    return is;
}

const int oo = INT32_MAX >> 1;
const ll OO = INT64_MAX >> 1;


void pre()
{

}

#define TEST 1

const int MAXN = 2e5 + 10;
bool vis[MAXN];
bool frame[MAXN];
bool loop[MAXN];
int sz[MAXN];

void solve()
{
    int n;
    cin >> n;
    vi a(n);
    cin >> a;

    rep(i, n) {
        a[i] += i;
    }

    vi next(n + 2);

    rep(i, n) {
        int ind = a[i];
        if (ind < 0) {
            next[i + 1] = 0;
            continue;
        }

        if (ind >= n) {
            next[i + 1] = n + 1;
            continue;
        }

        next[i + 1] = ind + 1;
    }

    fill(vis, vis + n + 2, false);
    fill(frame, frame + n + 2, false);
    fill(loop, loop + n + 2, false);

    ll c = 0;

    function<bool(int)> dfs = [&](int i) -> bool {
        if (i == 0 || i == n + 1) {
            return false;
        }

        vis[i] = true;
        frame[i] = true;

        int j = next[i];
        if (frame[j] || loop[j]) {
            loop[i] = true;
        }

        if (!vis[j] && dfs(j)) {
            loop[i] = true;
        }

        frame[i] = false;
        c += !loop[i];
        return loop[i];
    };

    rep(i, n) {
        if (!vis[i + 1]) {
            dfs(i + 1);
        }
    }
    
    stack<int> topsort;
    fill(vis, vis + n + 2, false);

    function<void(int)> ss = [&](int i) {
        if (i == 0 || i == n + 1) {
            return;
        }

        vis[i] = true;

        if (!vis[next[i]]) {
            ss(next[i]);
        }

        topsort.push(i);
    };

    rep(i, n) {
        if (!vis[i + 1] && !loop[i + 1]) {
            ss(i + 1);
        }
    }

    fill(sz, sz + n + 2, 1);

    while (!topsort.empty()) {
        auto i = topsort.top();
        topsort.pop();

        sz[next[i]] += sz[i];
    }

    if (loop[1]) {
        ll ans = c + n + 1;
        int now = next[1];
        fill(frame, frame + n + 2, false);
        frame[1] = true;
        while (!frame[now]) {
            ans += c + n + 1;
            frame[now] = true;
            now = next[now];
        }
        cout << ans << '\n';
        return;
    }

    ll ans = c - sz[1] + n + 1;
    int now = next[1];
    ll count = 1;
    while (now != n + 1 && now != 0) {
        ans += c - sz[now] + n + 1;
        count++;
        now = next[now];
    }

    ans += (n - count) * 2 * n + (n - count);
    
    cout << ans << '\n';
}

int main()
{
    ios::sync_with_stdio(false);
    cin.tie(nullptr);

    pre();

    int t;
    (TEST && cin >> t) || (t = 1);
    while (t--) {
        solve();
    }
}
